class xCharacterWindow extends CharacterWindow;

var	xCharsMenuPawn xCharacter;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function class<xCharsPawn> GetSelectedPawnClass()
{
	local class<xMpPawn> CharacterClass;
	local class<xCharsPawn> xCharsClass;

	CharacterClass = class<xMpPawn>(DynamicLoadObject(CurrentCharacter, class'class'));
	if (CharacterClass != None && ClassIsChildOf(CharacterClass, class'xCharsPawn'))
	{
		xCharsClass = class<xCharsPawn>(CharacterClass);
		return xCharsClass;
	}
}
/*
function SetHeadAndBodyInfo(xCharsPawn.HeadInfo H, xCharsPawn.BodyInfo B)
{
	local class<xCharsPawn> xCharsClass;

	if (xCharacter != None)
		xCharacter.SetHeadAndBodyInfo(H, B);

	xCharsClass = GetSelectedPawnClass();

	if (xCharsClass != None && xCharsClass.Default.bAllowCustomSkin)
	{
		xCharsClass.static.SetDesiredSkins(H, B);
	}
}
*/
function Created()
{
	local PlayerController PC;

	PC = root.ViewportOwner.Actor;
	if(xCharacter == None)
		xCharacter = PC.Spawn(class'xCharsMenuPawn', PC);
	xCharacter.LoopAnim('s_base1');
	NextAnimTime = CurrentTime + AnimChangeInterval;
}

function SetCharacter(string CharacterClassName)
{
	local class<xMpPawn> CharacterClass;
	local int i;

	if(CharacterClassName ~= "" || CharacterClassName ~= CurrentCharacter)
		return;

	CurrentCharacter = CharacterClassName;
	CharacterClass = class<xMpPawn>(DynamicLoadObject(CharacterClassName, class'class'));
	xCharacter.SetCharacter(CharacterClass);
	SetScale(CharacterScale);
}

function Close(optional bool bByParent)
{
	Super.Close(bByParent);
	if (xCharacter != None)
	{
		xCharacter.Destroy();
		xCharacter = None;
	}
}

function SetScale(float newScale)
{
	local int i;

	CharacterScale = newScale;
	if(xCharacter == None)
		return;
	xCharacter.SetDrawScale(CharacterScale);
	xCharacter.MyHead.SetDrawScale(CharacterScale);
	for (i = 0; i < ArrayCount(xCharacter.boltons); i++)
	{
		if (!xCharacter.boltons[i].bInActive && xCharacter.boltons[i].part != None)
			xCharacter.boltons[i].part.SetDrawScale(CharacterScale);
	}
}

function Paint(Canvas C, float X, float Y)
{
	local PlayerController PC;
	local Actor ViewTarget;
	local rotator CameraRotation;
	local vector CameraLocation;

	Super.Paint(C,X,Y);

	if (xCharacter != None && P2RootWindow(Root).IsMenuShowing())
	{
		// Set draw style
		C.Style = 1; //ERenderStyle.STY_Normal;
		C.SetDrawColor(255, 255, 255);

		// 65535 32768 16384

		PC = root.ViewportOwner.Actor;
		PC.PlayerCalcView(ViewTarget, CameraLocation, CameraRotation);

		CameraRotation.Pitch += 150;
		xCharacter.SetLocation(CameraLocation + 6.8*vector(CameraRotation));

		CameraRotation.Yaw += 32768;
		CameraRotation.Pitch = -CameraRotation.Pitch;
		xCharacter.SetRotation(CameraRotation + Rotation);

		C.DrawActor(xCharacter, false);
	}
//	else
//		Warn("Character is None!");
}

function PlayNextAnim()
{
	local name NewAnimName;

	if(xCharacter == None || AnimNames.Length == 0)
		return;

	NewAnimName = AnimNames[Rand(AnimNames.Length)];
	xCharacter.PlayAnim(NewAnimName, 1.0, 0.25);

	NextAnimTime = CurrentTime + AnimChangeInterval;
}

defaultproperties
{
     AnimNames(0)="s_base1"
     AnimNames(1)="s_dance2"
     AnimNames(2)="s_idle_crotch"
     AnimNames(3)="s_idle_survey"
     AnimNames(4)="s_idle_watch"
     AnimNames(5)="s_idle_stretch"
     AnimNames(6)="s_idle_shoe"
     AnimNames(7)="s_dance2"
     AnimNames(8)="s_nothing"
     AnimNames(9)="s_angry"
}
