class xCharsMenuPawn extends xMpDude;

///////////////////////////////////////////////////////////////////////////////
// Set this pawn's mesh
///////////////////////////////////////////////////////////////////////////////
simulated function SetMyMesh(Mesh NewMesh, optional Mesh NewCoreMesh, optional bool bKeepAnimState)
	{
	if (NewMesh != Mesh)
		{
		CoreSPMesh = NewCoreMesh;
		LinkMeshAndAnims(NewMesh, bKeepAnimState);
		}
	}

function SetCharacter(class<xMpPawn> CharacterClass)
{
	local int i;
	local class<xCharsPawn> xCharClass;

	// Set new mesh, skin and head mesh/skin
	SwitchToNewMesh(
		CharacterClass.Default.Mesh,
		CharacterClass.Default.Skins[0],
		CharacterClass.Default.HeadMesh,
		CharacterClass.Default.HeadSkin,
		CharacterClass.Default.CoreSPMesh
	);

	// Set new boltons
	DestroyBoltons();
	for(i = 0; i < ArrayCount(CharacterClass.Default.Boltons); i++)
		Boltons[i] = CharacterClass.Default.Boltons[i];
	SetupBoltons();

	// Make everything unlit
	bUnlit = true;
	MyHead.bUnlit = true;
	for(i = 0; i < ArrayCount(Boltons); i++)
	{
		if(Boltons[i].part != None)
			Boltons[i].part.bUnlit = true;
	}

	if (CharacterClass == class'xMpKrotchy')
		MyHead.SetDrawScale(0.01);

	else
		MyHead.SetDrawScale(1.0);

	if (CharacterClass == class'xMpKamek')
		Boltons[0].Part.SetRelativeRotation(class'xMpKamek'.Default.GlassesRotation);
//	else if (class<xCharsPawn>(CharacterClass) != None)
//	{
//		xCharClass = class<xCharsPawn>(CharacterClass);
//		if (xCharClass.Default.bAllowCustomSkin)
//			SetHeadAndBodyInfo(xCharClass.Default.DesiredHead, xCharClass.Default.DesiredBody);
//	}
}

function JumpOffPawn()
{
}

///////////////////////////////////////////////////////////////////////////////
// Don't allow any ragdoll stuff with these pawns
///////////////////////////////////////////////////////////////////////////////
function bool AllowRagdoll(class<DamageType> DamageType)
{
	return false;
}

function GetKarmaSkeleton()
{
	// STUB
}

defaultproperties
{
     ThisHeadAnim=MeshAnimation'heads.HeadAvg'
     BodyHitSounds(0)=Sound'MiscSounds.People.bodyhitground1'
     BodyHitSounds(1)=Sound'MiscSounds.People.bodyhitground2'
     ChameleonMeshPkgs(0)="Characters"
     ChamelHeadSkins(0)="ChamelHeadSkins.MWA__001__AvgMale"
     ChamelHeadSkins(1)="ChamelHeadSkins.MBA__013__AvgBrotha"
     ChamelHeadSkins(2)="ChamelHeadSkins.MBA__014__AvgBrotha"
     ChamelHeadSkins(3)="ChamelHeadSkins.MMA__016__AvgMale"
     ChamelHeadSkins(4)="ChamelHeadSkins.MMF__024__FatMale"
     ChamelHeadSkins(5)="ChamelHeadSkins.MWA__002__AvgMale"
     ChamelHeadSkins(6)="ChamelHeadSkins.MMA__003__AvgMale"
     ChamelHeadSkins(7)="ChamelHeadSkins.MWA__004__AvgMale"
     ChamelHeadSkins(8)="ChamelHeadSkins.MWA__005__AvgMale"
     ChamelHeadSkins(9)="ChamelHeadSkins.MWA__006__AvgMale"
     ChamelHeadSkins(10)="ChamelHeadSkins.MWA__007__AvgMale"
     ChamelHeadSkins(11)="ChamelHeadSkins.MWA__008__AvgMale"
     ChamelHeadSkins(12)="ChamelHeadSkins.MWA__009__AvgMale"
     ChamelHeadSkins(13)="ChamelHeadSkins.MWA__010__AvgMale"
     ChamelHeadSkins(14)="ChamelHeadSkins.MWA__011__AvgMale"
     ChamelHeadSkins(15)="ChamelHeadSkins.MWA__015__AvgMale"
     ChamelHeadSkins(16)="ChamelHeadSkins.MWA__021__AvgMaleBig"
     ChamelHeadSkins(17)="ChamelHeadSkins.MWA__035__AvgMale"
     ChamelHeadSkins(18)="ChamelHeadSkins.MWF__025__FatMale"
     ChamelHeadSkins(19)="ChamelHeadSkins.MWA__022__AvgMaleBig"
     ChamelHeadSkins(20)="ChamelHeadSkins.FBA__033__FemSH"
     ChamelHeadSkins(21)="ChamelHeadSkins.FMA__028__FemSH"
     ChamelHeadSkins(22)="ChamelHeadSkins.FMA__034__FemSH"
     ChamelHeadSkins(23)="ChamelHeadSkins.FWA__026__FemLH"
     ChamelHeadSkins(24)="ChamelHeadSkins.FWA__027__FemLH"
     ChamelHeadSkins(25)="ChamelHeadSkins.FWA__029__FemSH"
     ChamelHeadSkins(26)="ChamelHeadSkins.FWA__032__FemSH"
     ChamelHeadSkins(27)="ChamelHeadSkins.FWF__023__FatFem"
     ChamelHeadSkins(28)="ChamelHeadSkins.FWA__037__FemSHcropped"
     ChamelHeadSkins(29)="ChamelHeadSkins.FMA__038__FemSHcropped"
     ChamelHeadSkins(30)="ChamelHeadSkins.FMA__039__FemSHcropped"
     ChamelHeadSkins(31)="ChamelHeadSkins.FWA__040__FemSHcropped"
     ChamelHeadSkins(32)="ChamelHeadSkins.MBF__042__FatMale"
     ChamelHeadSkins(33)="ChamelHeadSkins.FBF__043__FatFem"
     ChamelHeadSkins(34)="ChamelHeadSkins.FMF__044__FatFem"
     ChamelHeadSkins(35)="ChamelHeadSkins.FWA__031__FemSH"
     ChamelHeadSkins(36)="ChamelHeadSkins.FBA__063__FemSH"
     ChamelHeadSkins(37)="End"
     ChamelHeadMeshPkgs(0)="heads"
     BaseEquipment(0)=(WeaponClass=Class'Inventory.UrethraWeapon')
     BaseEquipment(1)=(WeaponClass=Class'Inventory.FootWeapon')
     BaseEquipment(2)=(WeaponClass=Class'Inventory.MatchesWeapon')
     bHidden=True
     Skins(0)=Texture'ChameleonSkins.Special.Dude'
     CollisionRadius=0.000000
     CollisionHeight=0.000000
     bCollideActors=False
     bBlockActors=False
     bBlockPlayers=False
}
